function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

define(function (require) {
  var Component = require('Component');

  var template = require('/template/main');

  var $ = require('jquery');

  var _require = require('underscore'),
      random = _require.random;

  var TRANSITION = 'transform .5s ease';
  return Component.extend({
    template: template,
    events: {
      dom: {
        'click button': 'handleOnClick'
      }
    },
    _reducedMotionQueryCallback: function _reducedMotionQueryCallback(_ref) {
      var matches = _ref.matches;

      this._$rotationTarget.css('transition', matches ? this._originalTransition : TRANSITION);
    },
    onRendered: function onRendered() {
      this._rotation = 0;
      this._$rotationTarget = $('body > .sv-layout').first(); // Setup transition with support for reduced motion preference.

      this._originalTransition = this._$rotationTarget.css('transition');
      this._reducedMotionQuery = window.matchMedia('(prefers-reduced-motion: reduce)');

      this._reducedMotionQuery[typeof this._reducedMotionQuery.addEventListener === 'function' ? 'addEventListener' : 'addListener']('change', this._reducedMotionQueryCallback.bind(this));

      this._reducedMotionQueryCallback.call(this, this._reducedMotionQuery); // Place module as child to body to prevent rotation from being applied to button.


      this.$el.closest('.sv-custom-module').appendTo('body');
    },
    handleOnClick: function handleOnClick(e) {
      var currentRotation = this._rotation;

      if (this.state.rotationType === 'random') {
        this._rotation = random(0, 3) * 90; // Simple prevention of new rotation 
        // being the same as the current one.

        if (this._rotation === currentRotation) {
          this._rotation = (this._rotation + 90) % 360;
        }
      } else {
        // Assume all other rotation types are integers for addition.
        this._rotation += parseInt(this.state.rotationType) || 90;
      }

      this._$rotationTarget.css('transform', "rotate(".concat(this._rotation, "deg)"));
    },
    filterState: function filterState(state) {
      return _objectSpread({}, state);
    }
  });
});